// This file contains definitions for the global variable structure
// for RSInit.

#ifndef _RS_INIT_GLOBALS_H
#define _RS_INIT_GLOBALS_H

#include "../Common/DrvShare.h"

////////////////////////////////////////////////////////////////////////////
//                               MACROS
////////////////////////////////////////////////////////////////////////////

// The following flags are used to keep track of which resources have
// been allocated so far for this driver. Thus, if we have to exit, we
// can free those resources.

#define INTERFACE_DEVICE_RESOURCE_FLAG           1
#define SYMBOLIC_LINK_RESOURCE_FLAG              2
#define SHARED_STATE_RESOURCE_FLAG               4

////////////////////////////////////////////////////////////////////////////
//                             STRUCTURES
////////////////////////////////////////////////////////////////////////////

// This structure contains global data for RSInit:

typedef struct _rsinit_globals {

  // The resources obtained by this driver that must be freed before
  // unloading:
  ULONG resourcesObtained;

  // This driver object:
  PDRIVER_OBJECT ourDriver;

  // Our main device object:
  PDEVICE_OBJECT interfaceDeviceObject;

  // The state shared between this and all other drivers.
  SHARED_STATE *sharedState;

} RS_INIT_GLOBALS;

extern RS_INIT_GLOBALS g;

#endif
