// This file defines routines for incrementing and decrementing the
// I/O count.

#ifndef _RS_IOCNT_IO_COUNT_H
#define _RS_IOCNT_IO_COUNT_H

// This function (really a macro) increments the ongoing-I/O count.

#define IncrementIoCount() \
  InterlockedIncrement(&g.sharedState->numOngoingIos)

// This function (really a macro) decrements the ongoing-I/O count and,
// if it turns out to now be 0, calls the notification function for
// when no I/O's are ongoing.

#define DecrementIoCount() \
  if (InterlockedDecrement(&g.sharedState->numOngoingIos) == 0) \
    (*(g.sharedState->notifyIosCompleteFunc))()

#endif
