// This file contains routines for adding and removing reasons for
// not logging.

#include <ntddk.h>
#include "../Common/Drivers.h"
#include "../Common/DrvShare.h"
#include "StartStop.h"
#include "Globals.h"

// This function adds a reason to the set of reasons for not logging.

void AddReasonsForNotLogging (ULONG reasons)
{
  g.whyLoggingDisabled |= reasons;
  if (g.whyLoggingDisabled)
    g.sharedState->kernelUserSharedState.loggedEventCategorySet = 0;
}

// This function removes a reason from the set of reasons for not logging.

void RemoveReasonsForNotLogging (ULONG reasons)
{
  g.whyLoggingDisabled &= ~reasons;
  if (!g.whyLoggingDisabled)
    g.sharedState->kernelUserSharedState.loggedEventCategorySet =
      g.registryInfo.loggedEventCategorySet;
}
