// This file contains definitions relating to the idle thread.

#ifndef _RSTASK_IDLE_THREAD_H
#define _RSTASK_IDLE_THREAD_H

/////////////////////////////////////////////////////////////////////////////
// STRUCTURES
/////////////////////////////////////////////////////////////////////////////

// This structure contains information about the idle thread:

typedef struct _idle_thread_info {

  // This is the event the thread waits on before waking up and doing
  // anything:
  KEVENT threadWaitEvent;

  // This boolean indicates that the thread should terminate itself
  // the next time it wakes up:
  BOOLEAN shouldTerminate;

  // This is the thread object we reference:
  PVOID threadObject;

  // This is the client ID of the thread object:
  CLIENT_ID clientId;

} IDLE_THREAD_INFO, *PIDLE_THREAD_INFO;

/////////////////////////////////////////////////////////////////////////////
// FUNCTION PROTOTYPES
/////////////////////////////////////////////////////////////////////////////

NTSTATUS InitializeIdleThread (PIDLE_THREAD_INFO info);
void CloseIdleThread (PIDLE_THREAD_INFO info);
NTSTATUS GetIdleThreadTime (PLARGE_INTEGER hnsPtr);

#endif
