// This file contains definitions for I/O control functions.

#ifndef _RS_TASK_IOCTLS_H
#define _RS_TASK_IOCTLS_H

#include "TTGFile.h"

NTSTATUS IoctlEndTaskAndBeginAnother (
  PTTG_FILE ttgFile,
  PCHAR inBuf,
  ULONG inBufLength,
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlBeginTask (
  PTTG_FILE ttgFile,
  PCHAR inBuf,
  ULONG inBufLength,
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlEndTask (
  PCHAR inBuf,
  ULONG inBufLength
  );

NTSTATUS IoctlSetGlobalPolicy (
  PCHAR inBuf,
  ULONG inBufLength
  );

NTSTATUS IoctlQueryDeadline (
  PTTG_FILE ttgFile,
  PCHAR inBuf,
  ULONG inBufLength,
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlChangeDeadline (
  PTTG_FILE ttgFile,
  PCHAR inBuf,
  ULONG inBufLength
  );

NTSTATUS IoctlResetSample (
  PTTG_FILE ttgFile,
  PCHAR inBuf,
  ULONG inBufLength
  );

NTSTATUS IoctlResetAllSamples (
  PTTG_FILE ttgFile
  );

NTSTATUS IoctlAllowFileModification (
  PTTG_FILE ttgFile
  );

NTSTATUS IoctlFlush (
  PTTG_FILE ttgFile
  );

NTSTATUS IoctlFlushAllTTGFiles (void);

NTSTATUS IoctlQueryTTGFilePreamble (
  PTTG_FILE ttgFile,
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlQueryNumSpeeds (
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlQueryTTGDirectory (
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlPrepareForUninstall (void);

NTSTATUS IoctlGetFunctionPointer (
  PCHAR inBuf,
  ULONG inBufLength,
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlQueryAvailableSpeedsKHz (
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

NTSTATUS IoctlQueryIdleThreadTime (
  PCHAR outBuf,
  ULONG outBufLength,
  PULONG returnedBytesPtr
  );

#endif
