// This file contains definitions for manipulating the system timer
// resolution.

#ifndef _RSTASK_TIMER_RESOLUTION_H
#define _RSTASK_TIMER_RESOLUTION_H

typedef struct _timer_resolution_info {

  // The current timer resolution in hundreds of nanoseconds:
  ULONG schedulingIntervalHns;

  // The negative of this value:
  long negSchedulingIntervalHns;

  // Half of the value:
  ULONG halfSchedulingIntervalHns;

} TIMER_RESOLUTION_INFO, *PTIMER_RESOLUTION_INFO;

NTSTATUS InitializeTimerResolution (PTIMER_RESOLUTION_INFO info);
NTSTATUS RestoreTimerResolution (PTIMER_RESOLUTION_INFO info);

#endif
