// This file contains definitions for functions exported by RSLib.

#ifndef _RIGHTSPEED_COMMON_RSLIB_H
#define _RIGHTSPEED_COMMON_RSLIB_H

#define DLLIMPORT __declspec( dllimport )

DLLIMPORT HANDLE RightSpeedCreateFile (
  LPCSTR TTGFileName,
  DWORD CreationDisposition,
  DWORD NumTaskTypes,
  LPCSTR TaskTypeDescriptions[]
  );

DLLIMPORT DWORD RightSpeedBeginTask (
  HANDLE TTGHandle,
  DWORD TaskType
  );

DLLIMPORT BOOL RightSpeedEndTask (
  HANDLE TTGHandle,
  DWORD TaskId
  );

DLLIMPORT DWORD RightSpeedEndTaskAndBeginAnother (
  HANDLE TTGHandle,
  DWORD TaskId,
  DWORD TaskType
  );

DLLIMPORT void RightSpeedDisableAutomaticTasks (
  BOOL Disable
  );

DLLIMPORT void RightSpeedTemporarilyDisableAutomaticTasks (
  BOOL Disable
  );

DLLIMPORT BOOL RightSpeedQueryDeadline (
  HANDLE TTGHandle,
  DWORD TaskType,
  double *DeadlinePtr
  );

DLLIMPORT BOOL RightSpeedChangeDeadline (
  HANDLE TTGHandle,
  DWORD TaskType,
  double Deadline
  );

DLLIMPORT BOOL RightSpeedResetSample (
  HANDLE TTGHandle,
  DWORD TaskType
  );

DLLIMPORT BOOL RightSpeedResetAllSamples (
  HANDLE TTGHandle
  );

DLLIMPORT BOOL RightSpeedAllowFileModification (
  HANDLE TTGHandle
  );

DLLIMPORT BOOL RightSpeedFlush (
  HANDLE TTGHandle
  );

DLLIMPORT DWORD RightSpeedFormatMessage (
  DWORD err,
  LPTSTR buf,
  DWORD bufSize
  );

#endif
