// This file defines the RSInitHandle class, which represents an open
// handle to the RSInit device.

#ifndef _RSLIB_RSINIT_HANDLE_H
#define _RSLIB_RSINIT_HANDLE_H

#include "../Common/KernelUser.h"
#include <winsvc.h>

// This class represents an open handle to the RSInit device.

class RSInitHandle {
public:
  RSInitHandle();
  ~RSInitHandle() { Close(); }

  bool Initialize ();
  void WriteSpeedMsr (DWORD longRunCode1, DWORD longRunCode2);
  void Close ();

private:
  // This is the handle to the RSInit device:
  HANDLE h;

  // This is a handle to the service control manager:
  SC_HANDLE scManagerHandle;

  // This is a handle to the RSInit service:
  SC_HANDLE serviceHandle;

  // This boolean indicates whether we have to stop the RSInit service
  // when we close:
  bool mustStopRSInit;
};

#endif
