// This file contains definitions for writing the log to a file.

#ifndef _RSLOG_LOG_FILE_H
#define _RSLOG_LOG_FILE_H

// This structure contains information relevant to the current log file:

typedef struct _log_file_info {

  // This is the spin lock for access to this data structure:
  KSPIN_LOCK spinLock;

  // This event is used to signal the thread to wake up and flush:
  KEVENT waitEvent;

  // This is the thread object of the thread that writes the log file:
  PVOID threadObject;

  // This boolean indicates the thread is starting or stopping:
  BOOLEAN threadStartingOrStopping;
  
} LOG_FILE_INFO, *PLOG_FILE_INFO;

// These functions manipulate the log file information:

void InitializeLogFileInfo (PLOG_FILE_INFO info);
void CloseLogFileInfo (PLOG_FILE_INFO info);

NTSTATUS StartNextLogFile (void);
NTSTATUS TerminateCurrentLogFile (void);

#endif
