// This file contains definitions relevant to obtaining data from the
// registry.

#ifndef _RSLOG_REGISTRY_INFO_H
#define _RSLOG_REGISTRY_INFO_H

typedef struct _registry_info {

  // The version of RightSpeed:
  ULONG version;

  // The size of log buffer to allocate:
  ULONG logBufferSize;

  // The number of timestamp counter ticks per millisecond:
  ULONG tscTicksPerMs;

  // The main directory:
  UNICODE_STRING mainDirectory;

  // The event category set to use:
  RS_EVENT_CATEGORY_SET loggedEventCategorySet;
  
} REGISTRY_INFO;

NTSTATUS ReadRegistryInfo (REGISTRY_INFO *info);
void FreeRegistryInfo (REGISTRY_INFO *info);
NTSTATUS ReloadRegistryInfo (REGISTRY_INFO *info);

#endif
