// This file implements the class Parameters, which describes the set
// of parameters to use for this program.

#include "stdafx.h"
#include "Exceptions.h"
#include "Parameters.h"

Parameters::Parameters () :
  verbose(false),
  useGMT(false),
  skipContextSwitches(false)
{
}

void Parameters::HandleArgument (char *argument)
{
  switch (*argument) {
  case 'v' :
    verbose = true;
    break;
  case 'g' :
    useGMT = true;
    break;
  case 's' :
    skipContextSwitches = true;
    break;
  default :
    throw Exceptions::ParameterNotHandled();
  }
}
