#ifndef _NANOSEC_H
#define _NANOSEC_H

#include <windows.h>
#include <iostream>
#include "typeconv.h"

namespace jrl {

  // This file contains definitions for the classes Nanosec and Cycles.
  // Nanosec is an 8-byte time representing a number of
  // nanoseconds. Cycles is an 8-byte time representing a number of
  // cycles. Either of these can be relative (the difference between two
  // times) or absolute (the time since midnight on January 1, 1970).

  typedef LONGLONG Nanosec;
  typedef LONGLONG Cycles;

  // These functions return the highest values that Nanosec and Cycles
  // can attain:

  inline Cycles MaxCycles () { return jrl::MaxLonglong(); }
  inline Nanosec MaxNanosec () { return jrl::MaxLonglong(); }

}

#endif
