#include "stdafx.h"
#include <iomanip>
#include <time.h>
#include "nsconv.h"

// This file implements the member functions of the PrintableNs class.

using jrl::PrintableNs;

// This function prints the PrintableNs to the given output stream.

void PrintableNs::Print (ostream& os) const
{
  // Use the default fill character of 0 for all our printing.
  os.fill('0');

  // Determine the number of seconds this time represents. If it's
  // greater than 0x20000000, consider it to be an absolute time and
  // print it as such. Otherwise, consider it to be a relative time
  // and print it as such.

  unsigned long sec = ns / 1000000000;
  if (sec > 0x20000000) {
    time_t unixTime = sec;
    struct tm *calendar = gmtime(&unixTime);
    if (calendar) {
      os << setw(2) << calendar->tm_mon + 1 << '/';
      os << setw(2) << calendar->tm_mday << '/';
      os << setw(2) << (calendar->tm_year % 100) << ' ';
      os << setw(2) << calendar->tm_hour << ':';
      os << setw(2) << calendar->tm_min << ':';
      os << setw(2) << calendar->tm_sec;
    }
    else
      os << "unknown";
  }
  else {
    os << sec / 3600 << ':';
    os << setw(2) << (sec / 60) % 60 << ':';
    os << setw(2) << sec % 60;
  }

  // Output the fractional seconds left over.

  os << '.';
  os << setw(9) << (unsigned long)(ns % 1000000000);
}
