#ifndef _NSCONV_H
#define _NSCONV_H

#include <iostream>
#include "nanosec.h"

using namespace std;

// This file contains definitions for the class PrintableNs, which is
// used to print Nanosec values.

namespace jrl {

  // The PrintableNs class represents nanosecond values that can be
  // pretty-printed.

  class PrintableNs {
  public:
    PrintableNs(const Nanosec& nsVal, int lengthVal = 0)
      : ns(nsVal), length(lengthVal) { }

    void Print (ostream& os) const;

  private:
    Nanosec ns;   // The number of nanoseconds this represents
    int length;   // The number of characters the number should be padded to,
                  //   or 0 if no padding is required
  };

  // This function prints a PrintableNs to the given output stream.

  inline ostream& operator<< (ostream& os, const PrintableNs& p)
  { p.Print(os); return os; }

}

#endif
