// This file contains definitions for routines related to simple
// schedules.

#ifndef _RSTASK_SIMPLE_SCHEDULE_H
#define _RSTASK_SIMPLE_SCHEDULE_H

#include "../Common/Schedule.h"

void ComputeFlatSchedule (
  PSPEED_SCHEDULE schedule,
  long deadlineI,
  double desiredCpi
  );

void ComputeLongShortSchedule (
  PSPEED_SCHEDULE schedule,
  long deadlineI,
  long updatePeriodI
  );

void ComputePastPegSchedule (
  PSPEED_SCHEDULE schedule,
  long deadlineI,
  long updatePeriodI
  );

void ComputeLongRunSchedule (
  PSPEED_SCHEDULE schedule
  );

double GetPdcOfSchedule (
  PSPEED_SCHEDULE schedule,
  long deadlineI
  );

BOOLEAN IsSpeedScheduleValid (
  PSPEED_SCHEDULE schedule
  );
                              
#endif
