// This file contains the main routine for the RightSpeed RSLib
// dynamic link library.

#include <windows.h>
#include "Globals.h"

////////////////////////////////////////////////////////////////////////////
//                           DLL MAIN ROUTINE
////////////////////////////////////////////////////////////////////////////

// DllMain does either initialization or completion for this DLL
// when it is first attached to or detached from a process or
// thread.

BOOL WINAPI DllMain (HANDLE hInstance, DWORD what, LPVOID notUsed)
{
  switch (what) {
  case DLL_THREAD_ATTACH :           // On attachment to a thread...
    // Notify the hooks object that a thread is starting so that
    // it can hook it.

    if (g.initializedOK)
      g.hooks.NotifyThreadStarting(GetCurrentThreadId());
    break;

  case DLL_THREAD_DETACH :           // On detachment from a thread...
    // Notify the hooks object that a thread is stopping so that
    // it can unhook it.

    if (g.initializedOK)
      g.hooks.NotifyThreadEnding(GetCurrentThreadId());
    break;

  case DLL_PROCESS_ATTACH :          // On attachment to a process...
  case DLL_PROCESS_DETACH :          // On detachment from a process...
    break;
  }

  // Even when DllMain does nothing, it should still return TRUE, to
  // avoid a messy error message that the user has to click away.

  return TRUE;
}
