// This file contains routines for displaying error messages.

#include "stdafx.h"
#include <windows.h>
#include <iostream>
#include "../Common/RSLib.h"
#include "Helpers.h"

// This function displays an error message. The 'problem' passed is
// the thing that happened erroneously. To determine why it happened,
// this routine uses GetLastError() and formats the resulting message
// using the RightSpeed library routine.

void DisplayError (const string& problem)
{
  char buf[512];

  RightSpeedFormatMessage(GetLastError(), buf, 512);
  buf[0] = tolower(buf[0]);
  cerr << "ERROR - " << problem << " because " << buf;
}
