// This file defines the class representing a task type group file
// that can be opened for reading and printing.

#ifndef _TTGFILE_H
#define _TTGFILE_H

#include <iostream>
#include <string>
#include "../Common/TTG.h"

using namespace std;

class TTGFile {
public:
  TTGFile();
  ~TTGFile() { Close(); }

  void Open (string& fileName);
  void Close ();
  void Print (ostream& os);
  
private:
  void PrintPreamble (ostream& os);
  void PrintTaskTypeInformation (ostream& os, int index);

  // This is a handle to the file:
  HANDLE hFile;

  // This is a handle to the mapping of this file into this address
  // space:
  HANDLE hMap;

  // This is a pointer to the image of this file in memory:
  PTTG_INFO ttgInfo;

  // This is the size of the file:
  DWORD fileSize;
};
  
#endif
